/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox, delegateCombine } from "igniteui-react-core";
import { InputGroup } from "./InputGroup";
import { Label } from "./Label";
import { Input } from "./Input";
import { Suffix } from "./Suffix";
import { Icon } from "./Icon";
import { Popup } from "igniteui-react-layouts";
import { Calendar } from "./Calendar";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { DayOfWeek_$type } from "./DayOfWeek";
import { FirstWeek_$type } from "./FirstWeek";
import { DateFormats_$type } from "./DateFormats";
import { BrushUtil } from "igniteui-react-core";
import { DateTimeValueFormatter } from "./DateTimeValueFormatter";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { dateMinValue, dateGetDate, dateMaxValue, dateFromValues, dateGetMonth } from "igniteui-react-core";
import { stringContains, stringIsNullOrWhiteSpace } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let DatePickerView = /*@__PURE__*/ (() => {
    class DatePickerView extends Base {
        constructor() {
            super();
            this.a = null;
            this.c = null;
            this.j = null;
            this.d = null;
            this.l = null;
            this.k = null;
            this.i = null;
            this.f = null;
            this.e = null;
            this.h = null;
            this.g = null;
        }
        ae() {
        }
        ad(a) {
            if (a == null) {
                this.c = null;
                return;
            }
            this.c = a;
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.x();
            this.y();
            let d = this.c.rootWrapper.getChildAt(0);
            d.listen("keydown", runOn(this, this.v));
            d.listen("focusin", runOn(this, this.t));
            d.listen("focusout", runOn(this, this.u));
            document.addEventListener("click", runOn(this, this.z), false);
        }
        x() {
            if (this.c != null) {
                this.j = this.c.rootWrapper.getChildAt(0);
                this.j.setAttribute("tabIndex", "0");
                this.j.setStyleProperty("display", "flex");
                this.j.setStyleProperty("height", "100%");
                this.k = this.c.createElement("div");
                this.i = this.c.createElement("div");
                this.i.setRawStyleProperty("flex-grow", "1");
                this.f = this.c.createElement("div");
                this.f.setAttribute("aria-hidden", "true");
                this.e = this.c.createElement("div");
                this.h = this.c.createElement("div");
                this.h.setAttribute("aria-hidden", "true");
                this.g = this.c.createElement("div");
                this.a.ca();
                this.i.getChildAt(0).setAttribute("aria-expanded", "fasle");
                this.i.getChildAt(0).setAttribute("aria-invalid", "false");
                this.e.setStyleProperty("height", "16px");
                this.e.setStyleProperty("width", "16px");
                this.g.setStyleProperty("height", "16px");
                this.g.setStyleProperty("width", "16px");
                this.e.listen("click", runOn(this, this.w));
                this.g.listen("click", runOn(this, this.aa));
            }
        }
        ah(a) {
            if (this.c != null) {
                let b = this.c.getSubRenderer(this.j);
                a.provideContainer(b);
            }
        }
        aj(a) {
            if (this.c != null) {
                let b = this.c.getSubRenderer(this.k);
                a.provideContainer(b);
            }
        }
        ai(a) {
            if (this.c != null) {
                let b = this.c.getSubRenderer(this.i);
                a.provideContainer(b);
            }
        }
        al(a, b) {
            if (this.c != null) {
                let c = this.c.getSubRenderer(b);
                a.provideContainer(c);
            }
        }
        ag(a, b) {
            if (this.c != null) {
                let c = this.c.getSubRenderer(b);
                a.provideContainer(c);
            }
        }
        s() {
            return this.k;
        }
        r() {
            return this.i;
        }
        o() {
            return this.f;
        }
        n() {
            return this.e;
        }
        q() {
            return this.h;
        }
        p() {
            return this.g;
        }
        an(a) {
            if (this.i != null) {
                if (a) {
                    this.i.getChildAt(0).setAttribute("aria-expanded", "true");
                }
                else {
                    this.i.getChildAt(0).setAttribute("aria-expanded", "false");
                }
            }
        }
        ao(a) {
            if (a != null && a != "") {
                this.i.getChildAt(0).setAttribute("aria-label", a);
            }
            else {
                this.i.getChildAt(0).setAttribute("aria-label", "Select a date");
            }
        }
        am() {
            if (this.e != null) {
                if (this.a.aq == true) {
                    this.e.show();
                }
                else {
                    this.e.hide();
                }
            }
        }
        ab() {
            if (this.e != null) {
                this.e.hide();
            }
        }
        y() {
            if (this.c != null) {
                this.l = this.c.rootWrapper.getChildAt(1);
                this.d = this.c.createElement("div");
                this.d.setStyleProperty("width", "100%");
                this.d.setStyleProperty("height", "100%");
                this.d.setStyleProperty("display", "flex");
                this.a.cb();
                this.d.parent().setStyleProperty("height", "100%");
            }
        }
        ak(a) {
            if (this.c != null) {
                let b = this.c.getSubRenderer(this.l);
                a.provideRenderer(b);
            }
        }
        af(a) {
            if (this.c != null) {
                let b = this.c.getSubRenderer(this.d);
                a.provideContainer(b);
            }
        }
        m() {
            return this.d;
        }
        w(a) {
            this.a.b8();
            if (this.e != null) {
                this.e.hide();
            }
        }
        aa(a) {
            a.stopPropagation();
            this.a.cg();
        }
        v(a) {
            let b = a.which;
            if (b == 27) {
                this.a.b9();
            }
        }
        t(a) {
            this.a.focus();
            let b = (a.originalEvent.relatedTarget);
            if (!this.b(b)) {
                this.a.cm();
            }
        }
        u(a) {
            this.a.cf();
            let b = (a.originalEvent.relatedTarget);
            if (!this.b(b)) {
                this.a.cn();
            }
        }
        z(a) {
            let b = a.target;
            if (!this.b(b)) {
                this.a.b9();
            }
        }
        ap() {
            if (this.c != null) {
                let a = this.c.rootWrapper.getNativeElement();
                let b = a.getBoundingClientRect();
                ;
                return b;
            }
            return null;
        }
        b(a) {
            if (null == a) {
                return false;
            }
            let b = this.i.getNativeElement();
            let c = this.d.getNativeElement();
            return b.contains(a) || c.contains(a);
        }
        ac() {
        }
    }
    DatePickerView.$t = /*@__PURE__*/ markType(DatePickerView, 'DatePickerView');
    return DatePickerView;
})();
/**
 * @hidden
 */
export let DatePicker = /*@__PURE__*/ (() => {
    class DatePicker extends Base {
        constructor() {
            super();
            this.l = null;
            this.y = null;
            this.u = null;
            this.s = null;
            this.v = null;
            this.q = null;
            this.r = null;
            this.g = null;
            this.a4 = "dd";
            this.a8 = "mm";
            this.bb = "yyyy";
            this.a5 = "mdy";
            this.ba = "/";
            this.ah = false;
            this.an = false;
            this.am = false;
            this.a2 = null;
            this.propertyChanged = null;
            this.valueChanged = null;
            this.ae = null;
            this.aw = dateMinValue();
            this.av = dateMinValue();
            this.a7 = "";
            this.c6 = BrushUtil.g(255, 24, 29, 31);
            this.z = null;
            this.a9 = "";
            this.au = dateMinValue();
            this.at = dateMaxValue();
            this.c = 2;
            this.a = 1;
            this.aa = null;
            this.c7 = BrushUtil.g(255, 24, 29, 31);
            this.c5 = BrushUtil.g(255, 163, 172, 184);
            this.aj = true;
            this.ak = false;
            this.ag = true;
            this.ai = true;
            this.m = 0;
            this.o = 0;
            this.al = false;
            this.e = new DateTimeValueFormatter();
            this.h = 0;
            this.a6 = null;
            this.gotFocus = null;
            this.lostFocus = null;
            this.keyDown = null;
            this.changing = null;
            let a = new DatePickerView();
            a.a = this;
            this.l = a;
            this.l.ae();
        }
        cs(a, b) {
            this.a0 = b;
            if (this.y != null) {
                this.b9();
                this.ah = true;
            }
            this.c0();
            if (this.valueChanged != null) {
                this.valueChanged(this, ((() => {
                    let $ret = new ValueChangedEventArgs();
                    $ret.oldValue = a;
                    $ret.newValue = b;
                    return $ret;
                })()));
            }
            this.cw();
        }
        notifySizeChanged() {
            this.l.ac();
        }
        destroy() {
            if (this.g != null) {
                let a = this.g;
                a.valueChanged = delegateRemove(a.valueChanged, runOn(this, this.b6));
                let b = this.g;
                b.close = delegateRemove(b.close, runOn(this, this.b5));
            }
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.l.ad(a);
        }
        get af() {
            if (this.ae == null) {
                this.ae = new SRProvider(this.l.c);
                this.ae.cb("Calendar");
            }
            return this.ae;
        }
        get a0() {
            return this.aw;
        }
        set a0(a) {
            if (dateGetDate(a) < dateGetDate(this.ay) || dateGetDate(a) > dateGetDate(this.ax)) {
                a = this.aw;
            }
            let b = this.aw;
            this.aw = a;
            if (+b != +(this.aw)) {
                this.cr("Value", b, this.aw);
            }
        }
        get az() {
            return this.av;
        }
        set az(a) {
            let b = this.av;
            this.av = a;
            if (+b != +(this.av)) {
                this.cr("Today", b, this.av);
            }
        }
        get bp() {
            return this.a7;
        }
        set bp(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.cr("Label", b, this.a7);
            }
        }
        get c9() {
            return this.c6;
        }
        set c9(a) {
            let b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.cr("LabelTextColor", b, a);
            }
        }
        get ac() {
            return this.z;
        }
        set ac(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.cr("LabelTextStyle", b, this.z);
            }
        }
        get bw() {
            return this.a9;
        }
        set bw(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.cr("Placeholder", b, this.a9);
            }
        }
        get ay() {
            return this.au;
        }
        set ay(a) {
            let b = this.au;
            this.au = a;
            if (+b != +(this.au)) {
                this.cr("MinDate", b, this.au);
            }
        }
        get ax() {
            return this.at;
        }
        set ax(a) {
            let b = this.at;
            this.at = a;
            if (+b != +(this.at)) {
                this.cr("MaxDate", b, this.at);
            }
        }
        get d() {
            return this.c;
        }
        set d(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.cr("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.c));
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.cr("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.a));
            }
        }
        get ad() {
            return this.aa;
        }
        set ad(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.cr("TextStyle", b, this.aa);
            }
        }
        get da() {
            return this.c7;
        }
        set da(a) {
            let b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.cr("TextColor", b, this.c7);
            }
        }
        get c8() {
            return this.c5;
        }
        set c8(a) {
            let b = this.c5;
            this.c5 = a;
            if (b != this.c5) {
                this.cr("IconColor", b, this.c5);
            }
        }
        get aq() {
            return this.aj;
        }
        set aq(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.cr("ShowClearButton", b, this.aj);
            }
        }
        get ar() {
            return this.ak;
        }
        set ar(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.cr("ShowTodayButton", b, this.ak);
            }
        }
        get ao() {
            return this.ag;
        }
        set ao(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.cr("AllowTextInput", b, this.ag);
            }
        }
        get ap() {
            return this.ai;
        }
        set ap(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.cr("OpenOnFocus", b, this.ai);
            }
        }
        get n() {
            return this.m;
        }
        set n(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.cr("FirstDayOfWeek", enumGetBox(DayOfWeek_$type, b), enumGetBox(DayOfWeek_$type, this.m));
            }
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.cr("FirstWeekOfYear", enumGetBox(FirstWeek_$type, b), enumGetBox(FirstWeek_$type, this.o));
            }
        }
        get as() {
            return this.al;
        }
        set as(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.cr("ShowWeekNumbers", b, this.al);
            }
        }
        get i() {
            return this.h;
        }
        set i(a) {
            let b = this.h;
            this.h = a;
            if (this.h != b) {
                this.cr("DateFormat", enumGetBox(DateFormats_$type, b), enumGetBox(DateFormats_$type, this.h));
            }
        }
        get bm() {
            return this.a6;
        }
        set bm(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.cr("FormatString", b, this.a6);
            }
        }
        cr(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.cu(a, b, c);
        }
        cu(a, b, c) {
            switch (a) {
                case "Density":
                    this.cx();
                    break;
                case "BaseTheme":
                    this.cy();
                    break;
                case "Value":
                    if (this.g != null) {
                        this.g.as = this.a0;
                    }
                    this.c0();
                    break;
                case "Label":
                    if (this.v != null) {
                        this.v.text = this.bp;
                        if (this.bp != null && this.bp != "") {
                            if (!this.u.inputs.contains(this.v)) {
                                this.u.inputs.insert(0, this.v);
                            }
                        }
                        else {
                            if (this.u.inputs.contains(this.v)) {
                                this.u.inputs.remove(this.v);
                            }
                        }
                    }
                    break;
                case "Placeholder":
                    if (this.s != null) {
                        this.s.b8 = this.bw;
                        this.l.ao(this.bw);
                    }
                    break;
                case "Today":
                    if (this.g != null) {
                        this.g.ar = this.az;
                    }
                    break;
                case "MaxDate":
                    if (this.g != null) {
                        let d = Base.compareSimple(this.ay, this.ax);
                        if (d >= 0) {
                            this.ax = dateMaxValue();
                        }
                        this.g.ap = this.at;
                    }
                    break;
                case "MinDate":
                    if (this.g != null) {
                        this.g.aq = this.au;
                        let e = Base.compareSimple(this.ay, this.ax);
                        if (e >= 0) {
                            this.ax = dateMaxValue();
                            this.g.ap = this.ax;
                        }
                    }
                    break;
                case "TextStyle":
                    this.c1();
                    break;
                case "ShowClearButton":
                    if (this.s != null) {
                        if (this.s.cg != "") {
                            this.l.am();
                        }
                    }
                    break;
                case "LabelTextColor":
                case "LabelTextStyle":
                case "TextColor":
                case "IconColor":
                    this.c2();
                    break;
                case "ShowTodayButton":
                    if (this.g != null) {
                        this.g.z = this.ar;
                    }
                    break;
                case "AllowTextInput":
                    if (this.s != null) {
                        this.s.disabled = !this.ao;
                    }
                    break;
                case "OpenOnFocus": break;
                case "DateFormat":
                    this.e.j(this.i);
                    this.c0();
                    break;
                case "FormatString":
                    this.b7();
                    this.c0();
                    break;
                case "FirstDayOfWeek":
                    if (this.g != null) {
                        this.g.n = this.n;
                    }
                    break;
                case "ShowWeekNumbers":
                    if (this.g != null) {
                        this.g.aa = this.as;
                    }
                    break;
                case "FirstWeekOfYear":
                    if (this.g != null) {
                        this.g.q = this.p;
                    }
                    break;
            }
        }
        b7() {
            let a = '/';
            let b = this.bm.toLowerCase();
            if (stringContains(b, "/")) {
                a = '/';
            }
            else if (stringContains(b, "-")) {
                a = '-';
            }
            else if (stringContains(b, " ")) {
                a = ' ';
            }
            else if (stringContains(b, ".")) {
                a = '.';
            }
            else if (stringContains(b, ",")) {
                a = ',';
            }
            this.ba = a.toString();
            let c = b.split(a);
            if (c.length == 3) {
                let d = "";
                for (let e = 0; e < 3; e++) {
                    if (stringContains(c[e], "d")) {
                        d += "d";
                        switch (c[e]) {
                            case "d":
                                this.a4 = c[e];
                                break;
                            case "dd":
                                this.a4 = c[e];
                                break;
                            case "ddd":
                                this.a4 = c[e];
                                break;
                            case "dddd":
                                this.a4 = c[e];
                                break;
                            default:
                                this.a4 = "dd";
                                break;
                        }
                    }
                    else if (stringContains(c[e], "m")) {
                        d += "m";
                        switch (c[e]) {
                            case "m":
                                this.a8 = c[e];
                                break;
                            case "mm":
                                this.a8 = c[e];
                                break;
                            case "mmm":
                                this.a8 = c[e];
                                break;
                            case "mmmm":
                                this.a8 = c[e];
                                break;
                            default:
                                this.a8 = "mm";
                                break;
                        }
                        this.a8 = c[e];
                    }
                    else if (stringContains(c[e], "y")) {
                        d += "y";
                        switch (c[e]) {
                            case "yy":
                                this.bb = c[e];
                                break;
                            case "yyyy":
                                this.bb = c[e];
                                break;
                            default:
                                this.bb = "yyyy";
                                break;
                        }
                    }
                }
                if (d == "dmy" || d == "mdy" || d == "ymd") {
                    this.a5 = d;
                }
                else {
                    this.a5 = "mdy";
                }
            }
        }
        c2() {
            if (this.s != null) {
                this.s.dv = this.da;
            }
            if (this.q != null) {
                this.q.fill = this.c8;
            }
            if (this.r != null) {
                this.r.fill = this.c8;
            }
            if (this.v != null) {
                this.v.dc = this.c9;
                this.v.y = this.ac;
            }
        }
        cz() {
            if (this.u != null) {
            }
        }
        c1() {
            if (this.aa != null) {
                this.s.ac = this.aa;
            }
        }
        ca() {
            this.u = new InputGroup();
            this.l.ah(this.u);
            this.u.k = 0;
            this.u.d = this.b;
            this.u.h = this.d;
            this.v = new Label();
            this.l.aj(this.v);
            this.v.dc = this.c9;
            this.v.y = this.ac;
            this.u.appendContentChild(this.l.s());
            if (this.bp != null && this.bp != "") {
                this.v.text = this.bp;
                this.u.inputs.add(this.v);
            }
            this.s = new Input();
            this.l.ai(this.s);
            this.s.b1 = "text";
            if (this.aa != null) {
                this.s.ac = this.aa;
            }
            this.s.disabled = !this.ao;
            this.s.dv = this.da;
            this.u.appendContentChild(this.l.r());
            this.u.inputs.add(this.s);
            this.s.b8 = this.bw;
            this.l.ao(this.bw);
            let a = this.s;
            a.change = delegateCombine(a.change, runOn(this, this.ch));
            let b = this.s;
            b.changing = delegateCombine(b.changing, runOn(this, this.ci));
            let c = this.s;
            c.keyDown = delegateCombine(c.keyDown, runOn(this, this.cj));
            let d = new Suffix();
            this.l.al(d, this.l.o());
            this.q = new Icon();
            this.l.ag(this.q, this.l.n());
            this.q.svgPath = DatePicker.bf;
            this.q.fill = this.c8;
            d.appendContentChild(this.l.n());
            this.u.appendContentChild(this.l.o());
            this.u.inputs.add(d);
            this.c0();
            let e = new Suffix();
            this.l.al(e, this.l.q());
            this.r = new Icon();
            this.l.ag(this.r, this.l.p());
            this.r.svgPath = DatePicker.be;
            this.r.fill = this.c8;
            e.appendContentChild(this.l.p());
            this.u.appendContentChild(this.l.q());
            this.u.inputs.add(e);
        }
        cj(a, b) {
            this.cp(b);
            if (b.defaultPrevented) {
                return;
            }
            let c = b.keyCode;
            let d = b.modifiers;
            switch (c) {
                case 9:
                    this.am = true;
                    if (!this.an) {
                        this.c4(this.s.cg);
                    }
                    this.b9();
                    this.ah = true;
                    this.am = false;
                    break;
                case 13:
                    this.am = true;
                    if (!this.an) {
                        this.c4(this.s.cg);
                    }
                    this.b9();
                    this.ah = true;
                    this.am = false;
                    break;
                case 40:
                    if (d == 1) {
                        this.ct();
                        this.ce();
                    }
                    break;
                case 38:
                    if (d == 1) {
                        this.b9();
                    }
                    break;
            }
        }
        ci(a, b) {
            this.cl(b);
            if (b.value.length > 0) {
                this.l.am();
            }
            else {
                this.l.ab();
            }
        }
        ch(a, b) {
            this.an = true;
            this.c4(b.value);
            this.an = false;
        }
        c4(a) {
            let b = ['/', '-', ' ', '.', ','];
            let c = stringSplit(a, b, 1);
            let d = 0;
            let e = 0;
            let f = 0;
            let g = true;
            if (c.length == 3) {
                if (c[0].length == 0 || c[1].length == 0 || c[2].length == 0) {
                    g = false;
                }
                if (this.a5 == "dmy") {
                    d = parseInt(c[0]);
                    e = parseInt(c[1]);
                    f = parseInt(c[2]);
                }
                else if (this.a5 == "mdy") {
                    e = parseInt(c[0]);
                    d = parseInt(c[1]);
                    f = parseInt(c[2]);
                }
                else if (this.a5 == "ymd") {
                    f = parseInt(c[0]);
                    e = parseInt(c[1]);
                    d = parseInt(c[2]);
                }
                if (isNaN_(d) || isNaN_(f)) {
                    g = false;
                }
                if (f < 50) {
                    f = f + 2000;
                }
                if (isNaN_(e)) {
                    let h = "";
                    if (this.a5 == "dmy") {
                        h = c[1].toLowerCase();
                    }
                    else if (this.a5 == "mdy") {
                        h = c[0].toLowerCase();
                    }
                    else if (this.a5 == "ymd") {
                        h = c[1].toLowerCase();
                    }
                    let i = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full").toLowerCase() : "january";
                    let j = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short").toLowerCase() : "jan";
                    let k = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full").toLowerCase() : "february";
                    let l = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short").toLowerCase() : "feb";
                    let m = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full").toLowerCase() : "march";
                    let n = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short").toLowerCase() : "mar";
                    let o = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full").toLowerCase() : "april";
                    let p = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short").toLowerCase() : "apr";
                    let q = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full").toLowerCase() : "may";
                    let r = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short").toLowerCase() : "may";
                    let s = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full").toLowerCase() : "june";
                    let t = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short").toLowerCase() : "jun";
                    let u = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full").toLowerCase() : "july";
                    let v = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short").toLowerCase() : "jul";
                    let w = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full").toLowerCase() : "august";
                    let x = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short").toLowerCase() : "aug";
                    let y = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full").toLowerCase() : "september";
                    let z = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short").toLowerCase() : "sep";
                    let aa = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full").toLowerCase() : "october";
                    let ab = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short").toLowerCase() : "oct";
                    let ac = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full").toLowerCase() : "november";
                    let ad = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short").toLowerCase() : "nov";
                    let ae = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full").toLowerCase() : "december";
                    let af = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short").toLowerCase() : "dec";
                    if (h == i || h == j) {
                        e = 1;
                    }
                    else if (h == k || h == l) {
                        e = 2;
                    }
                    else if (h == m || h == n) {
                        e = 3;
                    }
                    else if (h == o || h == p) {
                        e = 4;
                    }
                    else if (h == q || h == r) {
                        e = 5;
                    }
                    else if (h == s || h == t) {
                        e = 6;
                    }
                    else if (h == u || h == v) {
                        e = 7;
                    }
                    else if (h == w || h == x) {
                        e = 8;
                    }
                    else if (h == y || h == z) {
                        e = 9;
                    }
                    else if (h == aa || h == ab) {
                        e = 10;
                    }
                    else if (h == ac || h == ad) {
                        e = 11;
                    }
                    else if (h == ae || h == af) {
                        e = 12;
                    }
                    else {
                        g = false;
                    }
                }
                if (e > 12 || e < 1) {
                    g = false;
                }
            }
            else {
                g = false;
            }
            if (g) {
                let ag = dateFromValues(f, e, d, 0, 0, 0, 0);
                let ah = Base.compareSimple(ag, this.ay);
                let ai = Base.compareSimple(ag, this.ax);
                if (ah < 0 || ai > 0) {
                    this.c0();
                }
                else {
                    this.c3(ag);
                    this.l.am();
                }
            }
            else {
                this.c0();
            }
        }
        c3(a) {
            let b = this.a0;
            this.cs(b, a);
        }
        c0() {
            if (this.s != null) {
                if (+(this.aw) != +(dateMinValue())) {
                    let a = "";
                    if (this.bm == null) {
                        a = this.e.i(this.a0);
                    }
                    else {
                        let b = this.a0.getDate().toString();
                        let c = b;
                        if (this.a4 == "dd") {
                            if (this.a0.getDate() < 10) {
                                b = "0" + b;
                            }
                        }
                        else if (this.a4 == "ddd") {
                            switch (this.a0.getDay()) {
                                case 0:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Short")) ? this.af.b1("Sunday_Short") : "Sun";
                                    break;
                                case 1:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Short")) ? this.af.b1("Monday_Short") : "Mon";
                                    break;
                                case 2:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Short")) ? this.af.b1("Tuesday_Short") : "Tue";
                                    break;
                                case 3:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Short")) ? this.af.b1("Wednesday_Short") : "Wed";
                                    break;
                                case 4:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Short")) ? this.af.b1("Thursday_Short") : "Thu";
                                    break;
                                case 5:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Short")) ? this.af.b1("Friday_Short") : "Fri";
                                    break;
                                case 6:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Short")) ? this.af.b1("Saturday_Short") : "Sat";
                                    break;
                            }
                        }
                        else if (this.a4 == "dddd") {
                            switch (this.a0.getDay()) {
                                case 0:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Full")) ? this.af.b1("Sunday_Full") : "Sunday";
                                    break;
                                case 1:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Full")) ? this.af.b1("Monday_Full") : "Monday";
                                    break;
                                case 2:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Full")) ? this.af.b1("Tuesday_Full") : "Tuesday";
                                    break;
                                case 3:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Full")) ? this.af.b1("Wednesday_Full") : "Wednesday";
                                    break;
                                case 4:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Full")) ? this.af.b1("Thursday_Full") : "Thursday";
                                    break;
                                case 5:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Full")) ? this.af.b1("Friday_Full") : "Friday";
                                    break;
                                case 6:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Full")) ? this.af.b1("Saturday_Full") : "Saturday";
                                    break;
                            }
                        }
                        let d = dateGetMonth(this.a0).toString();
                        if (this.a8 == "mm") {
                            if (dateGetMonth(this.a0) < 10) {
                                d = "0" + d;
                            }
                        }
                        else if (this.a8 == "mmm") {
                            switch (dateGetMonth(this.a0)) {
                                case 1:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short") : "Jan";
                                    break;
                                case 2:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short") : "Feb";
                                    break;
                                case 3:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short") : "Mar";
                                    break;
                                case 4:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short") : "Apr";
                                    break;
                                case 5:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short") : "May";
                                    break;
                                case 6:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short") : "Jun";
                                    break;
                                case 7:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short") : "Jul";
                                    break;
                                case 8:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short") : "Aug";
                                    break;
                                case 9:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short") : "Sep";
                                    break;
                                case 10:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short") : "Oct";
                                    break;
                                case 11:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short") : "Nov";
                                    break;
                                case 12:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short") : "Dec";
                                    break;
                            }
                        }
                        else if (this.a8 == "mmmm") {
                            switch (dateGetMonth(this.a0)) {
                                case 1:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full") : "January";
                                    break;
                                case 2:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full") : "February";
                                    break;
                                case 3:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full") : "March";
                                    break;
                                case 4:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full") : "April";
                                    break;
                                case 5:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full") : "May";
                                    break;
                                case 6:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full") : "June";
                                    break;
                                case 7:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full") : "July";
                                    break;
                                case 8:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full") : "August";
                                    break;
                                case 9:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full") : "September";
                                    break;
                                case 10:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full") : "October";
                                    break;
                                case 11:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full") : "November";
                                    break;
                                case 12:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full") : "December";
                                    break;
                            }
                        }
                        let e = this.a0.getFullYear().toString();
                        if (this.bb == "yy") {
                            e = e.substr(2);
                        }
                        if (this.a5 == "dmy") {
                            if (this.a4 == "ddd" || this.a4 == "dddd") {
                                a = b + this.ba + d + " " + c + this.ba + e;
                            }
                            else {
                                a = b + this.ba + d + this.ba + e;
                            }
                        }
                        else if (this.a5 == "mdy") {
                            if (this.a4 == "ddd" || this.a4 == "dddd") {
                                a = d + " " + c + this.ba + b + this.ba + e;
                            }
                            else {
                                a = d + this.ba + b + this.ba + e;
                            }
                        }
                        else if (this.a5 == "ymd") {
                            if (this.a4 == "ddd" || this.a4 == "dddd") {
                                a = e + this.ba + d + " " + c + this.ba + b;
                            }
                            else {
                                a = e + this.ba + d + this.ba + b;
                            }
                        }
                    }
                    this.s.cg = a;
                    this.l.am();
                }
                else {
                    this.s.cg = "";
                    this.l.ab();
                }
            }
        }
        b8() {
            let a = this.a0;
            let b = dateMinValue();
            if (this.s != null) {
                this.s.cg = "";
            }
            this.aw = dateMinValue();
            this.g.cf();
            this.cs(a, b);
        }
        cb() {
            this.y = new Popup();
            this.l.ak(this.y);
            this.g = new Calendar();
            this.l.af(this.g);
            if (+(this.ay) != +(dateMinValue())) {
                this.g.aq = this.ay;
            }
            if (+(this.ax) != +(dateMaxValue())) {
                this.g.ap = this.ax;
            }
            if (+(this.az) != +(dateMinValue())) {
                this.g.ar = this.az;
            }
            this.g.z = this.ar;
            this.g.n = this.n;
            this.g.aa = this.as;
            this.g.q = this.p;
            let a = this.g;
            a.valueChanged = delegateCombine(a.valueChanged, runOn(this, this.b6));
            let b = this.g;
            b.close = delegateCombine(b.close, runOn(this, this.b5));
            this.y.appendPopupContent(this.l.m());
        }
        b6(a, b) {
            this.cs(b.oldValue, b.newValue);
        }
        b5(a) {
            if (this.y.t) {
                this.b9();
                this.ah = true;
            }
        }
        cg() {
            if (this.ah == false) {
                if (this.y.t) {
                    this.b9();
                }
                else {
                    this.ct();
                }
            }
            else {
                this.ah = false;
            }
        }
        ct() {
            let a = this.l.ap();
            if (this.y != null) {
                this.y.showRelativeToExclusionRect(a, 0, 0);
            }
            this.l.an(true);
        }
        b9() {
            if (this.y != null) {
                this.y.ao();
            }
            if (this.g != null) {
                this.g.cq();
            }
            this.l.an(false);
            this.ah = false;
        }
        focus() {
            if (this.s != null) {
                this.s.focus();
            }
            if (!this.y.t) {
                if (this.ah == false) {
                    if (this.ao == false) {
                        this.ct();
                        this.ah = true;
                        window.setTimeout(() => this.ce(), 0);
                    }
                    else {
                        if (this.ap == true && this.am == false) {
                            this.ct();
                            this.ah = true;
                            window.setTimeout(() => this.ce(), 0);
                        }
                    }
                }
                else {
                    this.ah = false;
                }
            }
        }
        cf() {
        }
        cw() {
            if (this.s != null) {
                this.s.dd();
            }
        }
        ce() {
            this.g.ci();
        }
        cm() {
            let a = new GotFocusEventArgs();
            this.co(a);
        }
        cn() {
            let a = new LostFocusEventArgs();
            this.cq(a);
        }
        cy() {
        }
        cx() {
        }
        a3() {
            return this.f();
        }
        bj() {
            let a = this.f();
            return a.g();
        }
        f() {
            let a = new DatePickerVisualModelExport();
            a.b = this.d;
            a.a = this.b;
            a.e = this.y.ab();
            a.d = this.u.ia();
            a.c = this.g.bf();
            if (this.ad != null) {
                let b = this.ad;
                if (this.l != null && b.n == null) {
                    let c = this.l.c;
                    let d = FontUtil.getFontInfoFromString(c, b.fontString);
                    b.n = d.n;
                    b.d = d.d;
                    b.o = d.o;
                    b.q = d.q;
                    b.r = d.r;
                    b.s = d.s;
                }
                if (b.n != null) {
                    a.h = b.n;
                }
                if (!isNaN_(b.d)) {
                    a.f = b.d;
                }
                if (b.s != null) {
                    a.l = b.s;
                }
                if (b.q != null) {
                    a.j = b.q;
                }
                if (b.o != null) {
                    a.i = b.q;
                }
            }
            return a;
        }
        co(a) {
            if (null != this.gotFocus) {
                this.gotFocus(this, a);
            }
        }
        cq(a) {
            if (null != this.lostFocus) {
                this.lostFocus(this, a);
            }
        }
        cp(a) {
            if (null != this.keyDown) {
                this.keyDown(this, a);
            }
        }
        cl(a) {
            if (null != this.changing) {
                this.changing(this, a);
            }
        }
    }
    DatePicker.$t = /*@__PURE__*/ markType(DatePicker, 'DatePicker', Base.$, [INotifyPropertyChanged_$type]);
    DatePicker.be = "M20 3h-1V1h-2v2H7V1H5v2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 18H4V8h16v13z";
    DatePicker.bf = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    DatePicker.ab = null;
    return DatePicker;
})();
//# sourceMappingURL=DatePickerView_combined.js.map
