import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Button } from "./Button";
import { FontInfo } from "igniteui-react-core";
import { ButtonGroupOrientation } from "./ButtonGroupOrientation";
import { ButtonGroupDisplayStyle } from "./ButtonGroupDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ButtonGroupButtonCollection } from "./ButtonGroupButtonCollection";
import { ButtonGroupSelectionChangedEventArgs } from "./ButtonGroupSelectionChangedEventArgs";
import { ButtonGroupVisualModelExport } from "./ButtonGroupVisualModelExport";
/**
 * @hidden
 */
export declare class ButtonGroupView extends Base {
    static $t: Type;
    constructor();
    a: ButtonGroup;
    v(): void;
    d(): boolean;
    p(a: Button): void;
    r(a: Button): void;
    q(): void;
    private g;
    private b;
    private f;
    readonly l: any;
    readonly ab: Path;
    readonly e: boolean;
    t(a: DomRenderer): void;
    private m;
    z(a: string): void;
    y(): void;
    private n;
    w(): void;
    private c;
    private h;
    private i;
    private j;
    private k;
    s(): void;
    u(): void;
    aa(a: FontInfo): void;
    x(a: Button): void;
    o(a: any): void;
}
/**
 * @hidden
 */
export declare class ButtonGroup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private o;
    p: ButtonGroupDisplayStyle;
    private e;
    g: BaseControlTheme;
    private c4;
    appendContentChild(a: any): void;
    private c3;
    private c6;
    private i;
    k: ControlDisplayDensity;
    private h;
    j: ControlDisplayDensity;
    private a;
    d: number[];
    private u;
    private de;
    private c;
    private b;
    private _view;
    view: ButtonGroupView;
    destroy(): void;
    protected da(a: string, b: any, c: any): void;
    protected dc(a: string, b: any, c: any): void;
    private dl;
    private dg;
    private df;
    private aa;
    private dk;
    private dj;
    private di;
    static f: BaseControlTheme;
    ax: number;
    gz: Brush;
    g1: Brush;
    g0: Brush;
    g2: Brush;
    aw: number;
    g6: Brush;
    g3: Brush;
    g7: Brush;
    ha: Brush;
    g4: Brush;
    g5: Brush;
    g8: Brush;
    g9: Brush;
    static av: number;
    static gn: Brush;
    static gp: Brush;
    static go: Brush;
    static gq: Brush;
    static au: number;
    static gu: Brush;
    static gr: Brush;
    static gv: Brush;
    static gy: Brush;
    static gs: Brush;
    static gt: Brush;
    static gw: Brush;
    static gx: Brush;
    static ap: number;
    static fn: Brush;
    static fp: Brush;
    static fo: Brush;
    static fq: Brush;
    static ao: number;
    static fu: Brush;
    static fr: Brush;
    static fv: Brush;
    static fy: Brush;
    static fs: Brush;
    static ft: Brush;
    static fw: Brush;
    static fx: Brush;
    ar: number;
    fz: Brush;
    f1: Brush;
    f0: Brush;
    f2: Brush;
    aq: number;
    f6: Brush;
    f3: Brush;
    f7: Brush;
    ga: Brush;
    f4: Brush;
    f5: Brush;
    f8: Brush;
    f9: Brush;
    static at: number;
    static gb: Brush;
    static gd: Brush;
    static gc: Brush;
    static ge: Brush;
    static as: number;
    static gi: Brush;
    static gf: Brush;
    static gj: Brush;
    static gm: Brush;
    static gg: Brush;
    static gh: Brush;
    static gk: Brush;
    static gl: Brush;
    static an: number;
    static fb: Brush;
    static fd: Brush;
    static fc: Brush;
    static fe: Brush;
    static am: number;
    static fi: Brush;
    static ff: Brush;
    static fj: Brush;
    static fm: Brush;
    static fg: Brush;
    static fh: Brush;
    static fk: Brush;
    static fl: Brush;
    private dh;
    private ad;
    al: number;
    private dm;
    ez: Brush;
    private dp;
    e1: Brush;
    private du;
    e6: Brush;
    private dr;
    e3: Brush;
    private dn;
    e0: Brush;
    private dq;
    e2: Brush;
    private ac;
    ak: number;
    private dv;
    e7: Brush;
    private dy;
    fa: Brush;
    private ds;
    e4: Brush;
    private dt;
    e5: Brush;
    private dw;
    e8: Brush;
    private dx;
    e9: Brush;
    private ah;
    a1: number;
    private d7;
    hn: Brush;
    private d9;
    hp: Brush;
    private ee;
    hu: Brush;
    private eb;
    hr: Brush;
    private ec;
    hs: Brush;
    private d8;
    ho: Brush;
    private ea;
    hq: Brush;
    private ag;
    a0: number;
    private ed;
    ht: Brush;
    private ev;
    h7: Brush;
    private ey;
    ia: Brush;
    private ew;
    h8: Brush;
    private ex;
    h9: Brush;
    private aj;
    a3: number;
    private ef;
    hv: Brush;
    private eh;
    hx: Brush;
    private em;
    h2: Brush;
    private ej;
    hz: Brush;
    private ek;
    h0: Brush;
    private eg;
    hw: Brush;
    private ei;
    hy: Brush;
    private ai;
    a2: number;
    private el;
    h1: Brush;
    private er;
    h3: Brush;
    private eu;
    h6: Brush;
    static readonly cv: string;
    private es;
    h4: Brush;
    private et;
    h5: Brush;
    private af;
    az: number;
    private dz;
    hb: Brush;
    private d1;
    hd: Brush;
    private d6;
    hi: Brush;
    private d3;
    hf: Brush;
    private d4;
    hg: Brush;
    private d0;
    hc: Brush;
    private d2;
    he: Brush;
    private ae;
    ay: number;
    private d5;
    hh: Brush;
    private en;
    hj: Brush;
    private eq;
    hm: Brush;
    private eo;
    hk: Brush;
    private ep;
    hl: Brush;
    private q;
    r: ButtonGroupOrientation;
    private static a4;
    private a6;
    b5: string;
    private w;
    private v;
    disabled: boolean;
    private x;
    z: boolean;
    db(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected ab(): boolean;
    a5(): any;
    bq(): string;
    l(): ButtonGroupVisualModelExport;
    provideContainer(a: DomRenderer): void;
    private m;
    readonly buttons: ButtonGroupButtonCollection;
    selectionChanged: (sender: any, args: ButtonGroupSelectionChangedEventArgs) => void;
}
