import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { ElevationMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ButtonDisplayStyle } from "./ButtonDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
/**
 * @hidden
 */
export declare class ButtonView extends Base {
    static $t: Type;
    constructor();
    b: Button;
    aj(): void;
    g(): boolean;
    k: DomRenderer;
    private d;
    private h;
    readonly q: any;
    readonly r: any;
    ad(a: DomRenderer): void;
    af(): void;
    as(): void;
    ao(a: number): void;
    an(a: number): void;
    al(): void;
    ag(): void;
    ab(): void;
    ah(): void;
    ai(): void;
    private s;
    ap(): void;
    ak(): void;
    private t;
    private u;
    private v;
    private y;
    private x;
    private f;
    private w;
    aa(): void;
    private e;
    private n;
    private j;
    private i;
    private l;
    private c;
    private m;
    private p;
    private o;
    ac(): void;
    ae(): void;
    am(): void;
    aq(a: Brush, b: Brush): void;
    ar(a: number, b: ElevationMode): void;
    at(a: FontInfo): void;
    z(a: any): void;
    a(): number[];
}
/**
 * @hidden
 */
export declare class Button extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    view: ButtonView;
    destroy(): void;
    protected jx(a: string, b: any, c: any): void;
    protected jz(a: string, b: any, c: any): void;
    private kc;
    private j2;
    js(): void;
    jr(): void;
    ju(): void;
    jw(): void;
    jv(): void;
    private j1;
    static rr: Brush;
    static rf: Brush;
    static p6: Brush;
    static n: ElevationMode;
    static ri: Brush;
    static rj: Brush;
    static rk: Brush;
    static du: number;
    static dx: number;
    static dw: number;
    static dv: number;
    static rh: Brush;
    static rp: Brush;
    static kq: CornerRadius;
    static ba: number;
    static rg: Brush;
    static rq: Brush;
    static ro: Brush;
    static rn: Brush;
    static rl: Brush;
    static rm: Brush;
    static qk: Brush;
    static ql: Brush;
    static qm: Brush;
    static dh: number;
    static dk: number;
    static dj: number;
    static di: number;
    static qj: Brush;
    static qr: Brush;
    static kn: CornerRadius;
    static a7: number;
    static qi: Brush;
    static qs: Brush;
    static qq: Brush;
    static qp: Brush;
    static qn: Brush;
    static qo: Brush;
    static q6: Brush;
    static q7: Brush;
    static q8: Brush;
    static dq: number;
    static dt: number;
    static ds: number;
    static dr: number;
    static q5: Brush;
    static rd: Brush;
    static kp: CornerRadius;
    static a9: number;
    static q4: Brush;
    static re: Brush;
    static rc: Brush;
    static rb: Brush;
    static q9: Brush;
    static ra: Brush;
    static qv: Brush;
    static qw: Brush;
    static qx: Brush;
    static dl: number;
    static dp: number;
    static dn: number;
    static dm: number;
    static qu: Brush;
    static q2: Brush;
    static ko: CornerRadius;
    static a8: number;
    static qt: Brush;
    static q3: Brush;
    static q1: Brush;
    static q0: Brush;
    static qy: Brush;
    static qz: Brush;
    static p9: Brush;
    static qa: Brush;
    static qb: Brush;
    static dd: number;
    static dg: number;
    static df: number;
    static de: number;
    static p8: Brush;
    static qg: Brush;
    static km: CornerRadius;
    static a6: number;
    static p7: Brush;
    static qh: Brush;
    static qf: Brush;
    static qe: Brush;
    static qc: Brush;
    static qd: Brush;
    static o8: Brush;
    static ow: Brush;
    static nn: Brush;
    static l: ElevationMode;
    static oz: Brush;
    static o0: Brush;
    static o1: Brush;
    static cx: number;
    static c0: number;
    static cz: number;
    static cy: number;
    static oy: Brush;
    static o6: Brush;
    static ki: CornerRadius;
    static a2: number;
    static ox: Brush;
    static o7: Brush;
    static o5: Brush;
    static o4: Brush;
    static o2: Brush;
    static o3: Brush;
    static n1: Brush;
    static n2: Brush;
    static n3: Brush;
    static cl: number;
    static co: number;
    static cn: number;
    static cm: number;
    static n0: Brush;
    static n8: Brush;
    static kf: CornerRadius;
    static az: number;
    static nz: Brush;
    static n9: Brush;
    static n7: Brush;
    static n6: Brush;
    static n4: Brush;
    static n5: Brush;
    static on: Brush;
    static oo: Brush;
    static op: Brush;
    static ct: number;
    static cw: number;
    static cv: number;
    static cu: number;
    static om: Brush;
    static ou: Brush;
    static kh: CornerRadius;
    static a1: number;
    static ol: Brush;
    static ov: Brush;
    static ot: Brush;
    static os: Brush;
    static oq: Brush;
    static or: Brush;
    static oc: Brush;
    static od: Brush;
    static oe: Brush;
    static cp: number;
    static cs: number;
    static cr: number;
    static cq: number;
    static ob: Brush;
    static oj: Brush;
    static kg: CornerRadius;
    static a0: number;
    static oa: Brush;
    static ok: Brush;
    static oi: Brush;
    static oh: Brush;
    static of: Brush;
    static og: Brush;
    static nq: Brush;
    static nr: Brush;
    static ns: Brush;
    static ch: number;
    static ck: number;
    static cj: number;
    static ci: number;
    static np: Brush;
    static nx: Brush;
    static ke: CornerRadius;
    static ay: number;
    static no: Brush;
    static ny: Brush;
    static nw: Brush;
    static nv: Brush;
    static nt: Brush;
    static nu: Brush;
    static c: BaseControlTheme;
    sf: Brush;
    r3: Brush;
    nm: Brush;
    m: ElevationMode;
    r6: Brush;
    r7: Brush;
    r8: Brush;
    d2: number;
    d5: number;
    d4: number;
    d3: number;
    r5: Brush;
    sd: Brush;
    ks: CornerRadius;
    bc: number;
    r4: Brush;
    se: Brush;
    sc: Brush;
    sb: Brush;
    r9: Brush;
    sa: Brush;
    pm: Brush;
    pn: Brush;
    po: Brush;
    c5: number;
    c8: number;
    c7: number;
    c6: number;
    pl: Brush;
    pt: Brush;
    kk: CornerRadius;
    a4: number;
    pk: Brush;
    pu: Brush;
    ps: Brush;
    pr: Brush;
    pp: Brush;
    pq: Brush;
    ru: Brush;
    rv: Brush;
    rw: Brush;
    dy: number;
    d1: number;
    d0: number;
    dz: number;
    rt: Brush;
    r1: Brush;
    kr: CornerRadius;
    bb: number;
    rs: Brush;
    r2: Brush;
    r0: Brush;
    rz: Brush;
    rx: Brush;
    ry: Brush;
    px: Brush;
    py: Brush;
    pz: Brush;
    c9: number;
    dc: number;
    db: number;
    da: number;
    pw: Brush;
    p4: Brush;
    kl: CornerRadius;
    a5: number;
    pv: Brush;
    p5: Brush;
    p3: Brush;
    p2: Brush;
    p0: Brush;
    p1: Brush;
    pb: Brush;
    pc: Brush;
    pd: Brush;
    c1: number;
    c4: number;
    c3: number;
    c2: number;
    pa: Brush;
    pi: Brush;
    kj: CornerRadius;
    a3: number;
    o9: Brush;
    pj: Brush;
    ph: Brush;
    pg: Brush;
    pe: Brush;
    pf: Brush;
    private j3;
    private at;
    bh: number;
    private as;
    bg: number;
    private r;
    s: ButtonDisplayStyle;
    private f;
    h: ControlDisplayDensity;
    private b;
    d: BaseControlTheme;
    private e;
    g: ControlDisplayDensity;
    private k0;
    m8: Brush;
    private lb;
    nj: Brush;
    private k8;
    ng: Brush;
    private ky;
    m6: Brush;
    private bn;
    cg: number;
    private bl;
    ce: number;
    private bm;
    cf: number;
    private k9;
    nh: Brush;
    private j4;
    kb: CornerRadius;
    private kz;
    m7: Brush;
    private k1;
    m9: Brush;
    private k2;
    na: Brush;
    private k3;
    nb: Brush;
    private bk;
    cd: number;
    private i;
    k: ElevationMode;
    private la;
    ni: Brush;
    private k7;
    nf: Brush;
    private k4;
    nc: Brush;
    private k5;
    nd: Brush;
    private k6;
    ne: Brush;
    private an;
    aw: number;
    private mt;
    tv: Brush;
    private mv;
    tx: Brush;
    private mw;
    ty: Brush;
    private mx;
    tz: Brush;
    private b7;
    ep: number;
    private m0;
    t2: Brush;
    private mu;
    tw: Brush;
    private ca;
    es: number;
    private b9;
    er: number;
    private b8;
    eq: number;
    private av;
    bj: number;
    private ka;
    kx: CornerRadius;
    private m2;
    t4: Brush;
    private lr;
    su: Brush;
    private lt;
    sw: Brush;
    private lu;
    sx: Brush;
    private lv;
    sy: Brush;
    private bt;
    eb: number;
    private ly;
    s1: Brush;
    private ls;
    sv: Brush;
    private bw;
    ee: number;
    private bv;
    ed: number;
    private bu;
    ec: number;
    private l0;
    s3: Brush;
    private l1;
    s4: Brush;
    private lz;
    s2: Brush;
    private lw;
    sz: Brush;
    private lx;
    s0: Brush;
    private aq;
    be: number;
    private j7;
    ku: CornerRadius;
    private lc;
    nk: Brush;
    private le;
    sg: Brush;
    private lf;
    sh: Brush;
    private lg;
    si: Brush;
    private bo;
    d6: number;
    private j;
    o: ElevationMode;
    private l4;
    s7: Brush;
    private ld;
    nl: Brush;
    private cb;
    et: number;
    private by;
    eg: number;
    private bx;
    ef: number;
    private u;
    v: FontInfo;
    private m5;
    t7: Brush;
    private l6;
    s8: Brush;
    private m4;
    t6: Brush;
    private m3;
    t5: Brush;
    private m1;
    t3: Brush;
    private my;
    t0: Brush;
    private mz;
    t1: Brush;
    private l2;
    s5: Brush;
    private l3;
    s6: Brush;
    private ao;
    ax: number;
    private j5;
    kd: CornerRadius;
    private mi;
    tk: Brush;
    private mk;
    tm: Brush;
    private ml;
    tn: Brush;
    private mm;
    to: Brush;
    private b3;
    el: number;
    private mp;
    tr: Brush;
    private mj;
    tl: Brush;
    private b6;
    eo: number;
    private b5;
    en: number;
    private b4;
    em: number;
    private au;
    bi: number;
    private j9;
    kw: CornerRadius;
    private mr;
    tt: Brush;
    private ms;
    tu: Brush;
    private mq;
    ts: Brush;
    private mn;
    tp: Brush;
    private mo;
    tq: Brush;
    private lh;
    sj: Brush;
    private lj;
    sl: Brush;
    private lk;
    sm: Brush;
    private ll;
    sn: Brush;
    private bp;
    d7: number;
    private l5;
    sq: Brush;
    private li;
    sk: Brush;
    private bs;
    ea: number;
    private br;
    d9: number;
    private bq;
    d8: number;
    private ap;
    bd: number;
    private j6;
    kt: CornerRadius;
    private lp;
    ss: Brush;
    private lq;
    st: Brush;
    private lo;
    sr: Brush;
    private lm;
    so: Brush;
    private ln;
    sp: Brush;
    private l7;
    s9: Brush;
    private l9;
    tb: Brush;
    private ma;
    tc: Brush;
    private mb;
    td: Brush;
    private bz;
    eh: number;
    private me;
    tg: Brush;
    private l8;
    ta: Brush;
    private b2;
    ek: number;
    private b1;
    ej: number;
    private b0;
    ei: number;
    private ar;
    bf: number;
    private j8;
    kv: CornerRadius;
    private mg;
    ti: Brush;
    private mh;
    tj: Brush;
    private mf;
    th: Brush;
    private mc;
    te: Brush;
    private md;
    tf: Brush;
    private static ew;
    private e6;
    h7: string;
    private static ev;
    private e5;
    h5: string;
    private e2;
    gb: string;
    private e3;
    he: string;
    private e4;
    hg: string;
    private e0;
    fv: string;
    private ex;
    ez: any;
    private e7;
    ig: string;
    private cc;
    private z;
    readonly ah: boolean;
    eu: number;
    private e1;
    fx: string;
    private ab;
    focused: boolean;
    private ac;
    ak: boolean;
    private x;
    af: boolean;
    private w;
    ae: boolean;
    private ad;
    al: boolean;
    private aa;
    disabled: boolean;
    private y;
    ag: boolean;
    jy(): void;
    private readonly a;
    private jp;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    appendButtonContent(a: any): void;
    protected am(): boolean;
    ey(): any;
    gf(): string;
    p(): ButtonVisualModelExport;
    provideContainer(a: DomRenderer): void;
    clicked: (sender: any, args: ButtonClickEventArgs) => void;
}
