import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
/**
 * @hidden
 */
export declare class CalendarView extends Base {
    static $t: Type;
    private j;
    private k;
    private n;
    private m;
    private o;
    private f;
    private e;
    private g;
    private h;
    private l;
    private q;
    constructor();
    c: Calendar;
    ad(): void;
    i: DomRenderer;
    ac(a: DomRenderer): void;
    r(): string;
    private u;
    private am;
    an(): void;
    private al;
    ap(): void;
    aq(): void;
    ak(): void;
    ah(a?: boolean, b?: boolean): void;
    aj(): void;
    ao(): void;
    ag(a?: boolean): void;
    ai(a?: boolean): void;
    d(a: DomWrapper): boolean;
    w(): void;
    private af;
    private aa;
    private ar;
    private as;
    private s;
    private t;
    private p;
    private ae;
    private z;
    private y;
    private av;
    private v;
    private x;
    private at;
    private au;
    a(): number[];
    b(a: DomWrapper): number[];
    ab(): void;
}
/**
 * @hidden
 */
export declare class Calendar extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private k;
    private static readonly bg;
    private static readonly bh;
    am: Date;
    private aj;
    private ae;
    private af;
    private ac;
    private ag;
    private ai;
    private ah;
    private ad;
    private h;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    close: (sender: any) => void;
    ck(): void;
    valueChanged: (sender: any, args: ValueChangedEventArgs) => void;
    cm(a: Date): void;
    cg(a: string, b: string, c: string): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private u;
    private readonly v;
    private ao;
    as: Date;
    private an;
    ar: Date;
    private al;
    aq: Date;
    private ak;
    ap: Date;
    private e;
    f: ControlDisplayDensity;
    private c;
    d: BaseControlTheme;
    private c7;
    dh: Brush;
    private dd;
    dn: Brush;
    private df;
    dq: Brush;
    private da;
    dk: Brush;
    private dc;
    dm: Brush;
    private dg;
    dr: Brush;
    private de;
    dp: Brush;
    private db;
    dl: Brush;
    private c9;
    dj: Brush;
    private c8;
    di: Brush;
    private w;
    z: boolean;
    private s;
    t: FontInfo;
    private m;
    n: DayOfWeek;
    private p;
    q: FirstWeek;
    private x;
    aa: boolean;
    protected cl(a: string, b: any, c: any): void;
    protected cn(a: string, b: any, c: any): void;
    private c5;
    private c6;
    ci(): void;
    private cu;
    private cs;
    cf(): void;
    private cp;
    ca(a: DomRenderer, b: DomWrapper, c: DomWrapper, d: List$1<DomWrapper>): void;
    cd(a: DomRenderer, b: DomWrapper): void;
    private c4;
    c3(a: DomWrapper): void;
    cc(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    ce(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    private cb;
    private ab;
    private a5;
    private static readonly a;
    private static readonly b;
    private a6;
    private a4;
    private a7;
    private a8;
    private a3;
    private o;
    private a2;
    private a9;
    private static y;
    cw(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    b7(a: List$1<DomWrapper>): void;
    ct(a: DomWrapper): void;
    c2(a: DomWrapper): void;
    cy(a: DomWrapper): void;
    cv(a: List$1<DomWrapper>, b?: boolean, c?: boolean): void;
    cz(a: DomWrapper): void;
    cx(a: List$1<DomWrapper>): void;
    c1(a: List$1<DomWrapper>): void;
    c0(a: List$1<DomWrapper>, b: number, c?: boolean): void;
    private j;
    private i;
    b6(a: number): void;
    b8(a: number): void;
    b9(a: number): void;
    cr(a: List$1<DomWrapper>, b: number): void;
    cq(): void;
    bf(): any;
    bo(): string;
    g(): CalendarVisualModelExport;
}
