import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { InputGroup } from "./InputGroup";
import { Label } from "./Label";
import { Input } from "./Input";
import { Suffix } from "./Suffix";
import { Icon } from "./Icon";
import { Popup } from "igniteui-react-layouts";
import { Calendar } from "./Calendar";
import { Rect } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
import { DateFormats } from "./DateFormats";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
import { KeyEventArgs } from "igniteui-react-core";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
/**
 * @hidden
 */
export declare class DatePickerView extends Base {
    static $t: Type;
    constructor();
    a: DatePicker;
    ae(): void;
    c: DomRenderer;
    private j;
    private d;
    private l;
    private k;
    private i;
    private f;
    private e;
    private h;
    private g;
    ad(a: DomRenderer): void;
    private x;
    ah(a: InputGroup): void;
    aj(a: Label): void;
    ai(a: Input): void;
    al(a: Suffix, b: any): void;
    ag(a: Icon, b: any): void;
    s(): any;
    r(): any;
    o(): any;
    n(): any;
    q(): any;
    p(): any;
    an(a: boolean): void;
    ao(a: string): void;
    am(): void;
    ab(): void;
    private y;
    ak(a: Popup): void;
    af(a: Calendar): void;
    m(): any;
    private w;
    private aa;
    private v;
    private t;
    private u;
    private z;
    ap(): Rect;
    private b;
    ac(): void;
}
/**
 * @hidden
 */
export declare class DatePicker extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private l;
    private static readonly be;
    private static readonly bf;
    private y;
    private u;
    private s;
    private v;
    private q;
    private r;
    private g;
    private a4;
    private a8;
    private bb;
    private a5;
    private ba;
    private ah;
    private an;
    private am;
    private a2;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    valueChanged: (sender: any, args: ValueChangedEventArgs) => void;
    cs(a: Date, b: Date): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private ae;
    private readonly af;
    private aw;
    a0: Date;
    private av;
    az: Date;
    private a7;
    bp: string;
    private c6;
    c9: Brush;
    private static ab;
    private z;
    ac: FontInfo;
    private a9;
    bw: string;
    private au;
    ay: Date;
    private at;
    ax: Date;
    private c;
    d: ControlDisplayDensity;
    private a;
    b: BaseControlTheme;
    private aa;
    ad: FontInfo;
    private c7;
    da: Brush;
    private c5;
    c8: Brush;
    private aj;
    aq: boolean;
    private ak;
    ar: boolean;
    private ag;
    ao: boolean;
    private ai;
    ap: boolean;
    private m;
    n: DayOfWeek;
    private o;
    p: FirstWeek;
    private al;
    as: boolean;
    private e;
    private h;
    i: DateFormats;
    private a6;
    bm: string;
    protected cr(a: string, b: any, c: any): void;
    protected cu(a: string, b: any, c: any): void;
    private b7;
    private c2;
    private cz;
    private c1;
    ca(): void;
    private cj;
    private ci;
    private ch;
    c4(a: string): void;
    private c3;
    private c0;
    b8(): void;
    cb(): void;
    private b6;
    private b5;
    cg(): void;
    ct(): void;
    b9(): void;
    focus(): void;
    cf(): void;
    cw(): void;
    ce(): void;
    cm(): void;
    cn(): void;
    private cy;
    private cx;
    a3(): any;
    bj(): string;
    f(): DatePickerVisualModelExport;
    gotFocus: (sender: any, args: GotFocusEventArgs) => void;
    lostFocus: (sender: any, args: LostFocusEventArgs) => void;
    keyDown: (sender: any, args: KeyEventArgs) => void;
    changing: (sender: any, args: InputChangeEventArgs) => void;
    co(a: GotFocusEventArgs): void;
    cq(a: LostFocusEventArgs): void;
    cp(a: KeyEventArgs): void;
    cl(a: InputChangeEventArgs): void;
}
